/*

    File: bindings_ARB_vertex_program.cpp

    Copyright (C) 2000-2010 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <iostream>
#include "system/gl.h"
#include "base/opengl.h"
#include "shader/shaderext.h"
#include "program.h"
#include "bindings_ARB_vertex_program.h"

using namespace std;

//now there is no auto type conversion in gl vertexattrib
//so here's the question
//do we a do a query and type convert within lua *here*
//or do we put it in the users hands?
// i know type conversion was denied for uniforms ...
// maybe it wont be for the attribs?
LUAFstart(glVertexAttrib1dvARB)
	if (argc < 1) {
		con << "glVertexAttrib expect at least one param" << endl;
		return 0;
	}
	int loc = -1;
	if (lua_isnumber(L,1)) {
		loc = (int)lua_tonumber(L,1);
	} else if (lua_isstring(L,1)) {
		loc = glGetAttribLocationARB(glGetHandleARB(GL_PROGRAM_OBJECT_ARB), lua_tostring(L,1));
	}
	if (argc == 2) {
		if (lua_istable(L,2)) {
			int len = lua_objlen(L,2);
			if (len == 1) glVertexAttrib1dvARB(loc, luaReadVec1d(L) );
			else if (len == 2) glVertexAttrib2dvARB(loc, luaReadVec2d(L) );
			else if (len == 3) glVertexAttrib3dvARB(loc, luaReadVec3d(L) );
			else if (len == 4) glVertexAttrib4dvARB(loc, luaReadVec4d(L) );
			else con << "glVertexAttrib table parameter got an unknown size " << len << endl;
		} else {
			glVertexAttrib1dARB(loc, LUAPd(2));
		}
	} else
	LUAFvarcase(3, glVertexAttrib2dARB(loc, LUAPd(2), LUAPd(3)))
	LUAFvarcase(4, glVertexAttrib3dARB(loc, LUAPd(2), LUAPd(3), LUAPd(4)))
	LUAFvarcase(5, glVertexAttrib4dARB(loc, LUAPd(2), LUAPd(3), LUAPd(4), LUAPd(5)))
	LUAFvarendcase("table, 2, 3, 4, or 5")
LUAFend()

static const luaL_reg luaBindings_ARB_vertex_program[] = {
	{NULL,NULL}
};

void luaBindGL_ARB_vertex_program(lua_State *L) {
	lua_getglobal(L, "gl");
	LUA_GLUE_FUNC_SAFE_SUFFIX(glVertexAttrib, 1dvARB)
	lua_pop(L,1);
}
