/*

    File: bindings_ARB_vertex_shader.cpp

    Copyright (C) 2000-2010 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <iostream>
#include "system/gl.h"
#include "base/opengl.h"
#include "shader/shaderext.h"
#include "program.h"
#include "bindings_ARB_vertex_shader.h"

using namespace std;

/*
TODO - inheritence / extensibility
a class object for quick registering all components into Lua?
or an overridden callback for glGet cases
or some way to speed things up / extend upon glGet...
*/

LUAFstart(glGetAttribLocationARB)
	GLhandleARB progh = (GLhandleARB)(int)lua_tonumber(L,1);
	if (!lua_isstring(L,2)) {
		con << "glGetAttribLocation expected a string for its second param" << endl;
		return 0;
	}
	lua_pushinteger(L, glGetAttribLocationARB(progh, lua_tostring(L,2)));
	return 1;
LUAFend()

void luaBindGL_ARB_vertex_shader(lua_State *L) {
	lua_getglobal(L, "gl");
	LUA_GLUE_FUNC_SAFE_ARB(glGetAttribLocation)
	//TODO - any defined constants here
	lua_pop(L,1);
}
