/*

    File: bindings_EXT_framebuffer_object.cpp

    Copyright (C) 2000-2010 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <iostream>
#include "system/gl.h"
#include "base/opengl.h"
#include "program.h"
#include "bindings_EXT_framebuffer_object.h"

using namespace std;

LUAF2i			(glBindFramebufferEXT)
LUAF2i			(glBindRenderbufferEXT)
LUAFiri			(glCheckFramebufferStatusEXT)

LUAFstart(glDeleteFramebuffersEXT)
	for (int i = 0; i < argc; i++) {
		GLuint id = LUAPi(i);
		glDeleteFramebuffersEXT(1, &id);
	}
LUAFend()

LUAFstart(glDeleteRenderbuffersEXT)
	for (int i = 0; i < argc; i++) {
		GLuint id = LUAPi(i);
		glDeleteRenderbuffersEXT(1, &id);
	}
LUAFend()

LUAF4i			(glFramebufferRenderbufferEXT)
LUAF5i			(glFramebufferTexture1DEXT)
LUAF5i			(glFramebufferTexture2DEXT)
LUAF6i			(glFramebufferTexture3DEXT)
LUAFuip			(glGenFramebuffersEXT)
LUAFuip			(glGenRenderbuffersEXT)
LUAFi			(glGenerateMipmapEXT)
LUAFirb			(glIsFramebufferEXT)
LUAFirb			(glIsRenderbufferEXT)
LUAF4i			(glRenderbufferStorageEXT)

void luaBindGL_EXT_framebuffer_object(lua_State *L) {
	lua_getglobal(L, "gl");
	
	//luaAddBindings(L, luaBindings_EXT_framebuffer_object);
	LUA_GLUE_FUNC_SAFE_EXT(glBindFramebuffer)
	LUA_GLUE_FUNC_SAFE_EXT(glBindRenderbuffer)
	LUA_GLUE_FUNC_SAFE_EXT(glCheckFramebufferStatus)
	LUA_GLUE_FUNC_SAFE_sEXT(glDeleteFramebuffer)
	LUA_GLUE_FUNC_SAFE_sEXT(glDeleteRenderbuffer)
	LUA_GLUE_FUNC_SAFE_EXT(glFramebufferRenderbuffer)
	LUA_GLUE_FUNC_SAFE_EXT(glFramebufferTexture1D)
	LUA_GLUE_FUNC_SAFE_EXT(glFramebufferTexture2D)
	LUA_GLUE_FUNC_SAFE_EXT(glFramebufferTexture3D)
	LUA_GLUE_FUNC_SAFE_sEXT(glGenFramebuffer)	//one at a time for now
	LUA_GLUE_FUNC_SAFE_sEXT(glGenRenderbuffer)
	//GetFramebufferAttachmentParameterivEXT
	//GetRenderbufferParameterivEXT
	LUA_GLUE_FUNC_SAFE_EXT(glGenerateMipmap)
	LUA_GLUE_FUNC_SAFE_EXT(glIsFramebuffer)
	LUA_GLUE_FUNC_SAFE_EXT(glIsRenderbuffer)
	LUA_GLUE_FUNC_SAFE_EXT(glRenderbufferStorage)
	
	//and the defs ...
	LUAGiEXT(GL_FRAMEBUFFER)
	LUAGiEXT(GL_RENDERBUFFER)
	LUAGiEXT(GL_STENCIL_INDEX1)
	LUAGiEXT(GL_STENCIL_INDEX4)
	LUAGiEXT(GL_STENCIL_INDEX8)
	LUAGiEXT(GL_STENCIL_INDEX16)
	LUAGiEXT(GL_RENDERBUFFER_WIDTH)
	LUAGiEXT(GL_RENDERBUFFER_HEIGHT)
	LUAGiEXT(GL_RENDERBUFFER_INTERNAL_FORMAT)
	LUAGiEXT(GL_RENDERBUFFER_RED_SIZE)
	LUAGiEXT(GL_RENDERBUFFER_GREEN_SIZE)
	LUAGiEXT(GL_RENDERBUFFER_BLUE_SIZE)
	LUAGiEXT(GL_RENDERBUFFER_ALPHA_SIZE)
	LUAGiEXT(GL_RENDERBUFFER_DEPTH_SIZE)
	LUAGiEXT(GL_RENDERBUFFER_STENCIL_SIZE)
	LUAGiEXT(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE)
	LUAGiEXT(GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME)
	LUAGiEXT(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL)
	LUAGiEXT(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE)
	LUAGiEXT(GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_3D_ZOFFSET)
	LUAGiEXT(GL_COLOR_ATTACHMENT0)
	LUAGiEXT(GL_COLOR_ATTACHMENT1)
	LUAGiEXT(GL_COLOR_ATTACHMENT2)
	LUAGiEXT(GL_COLOR_ATTACHMENT3)
	LUAGiEXT(GL_COLOR_ATTACHMENT4)
	LUAGiEXT(GL_COLOR_ATTACHMENT5)
	LUAGiEXT(GL_COLOR_ATTACHMENT6)
	LUAGiEXT(GL_COLOR_ATTACHMENT7)
	LUAGiEXT(GL_COLOR_ATTACHMENT8)
	LUAGiEXT(GL_COLOR_ATTACHMENT9)
	LUAGiEXT(GL_COLOR_ATTACHMENT10)
	LUAGiEXT(GL_COLOR_ATTACHMENT11)
	LUAGiEXT(GL_COLOR_ATTACHMENT12)
	LUAGiEXT(GL_COLOR_ATTACHMENT13)
	LUAGiEXT(GL_COLOR_ATTACHMENT14)
	LUAGiEXT(GL_COLOR_ATTACHMENT15)
	LUAGiEXT(GL_DEPTH_ATTACHMENT)
	LUAGiEXT(GL_STENCIL_ATTACHMENT)
	LUAGiEXT(GL_FRAMEBUFFER_COMPLETE)
	LUAGiEXT(GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT)
	LUAGiEXT(GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT)
//	LUAGiEXT(GL_FRAMEBUFFER_INCOMPLETE_DUPLICATE_ATTACHMENT)
	LUAGiEXT(GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS)
	LUAGiEXT(GL_FRAMEBUFFER_INCOMPLETE_FORMATS)
	LUAGiEXT(GL_FRAMEBUFFER_INCOMPLETE_DRAW_BUFFER)
	LUAGiEXT(GL_FRAMEBUFFER_INCOMPLETE_READ_BUFFER)
	LUAGiEXT(GL_FRAMEBUFFER_UNSUPPORTED)
	LUAGiEXT(GL_FRAMEBUFFER_BINDING)
	LUAGiEXT(GL_RENDERBUFFER_BINDING)
	LUAGiEXT(GL_MAX_COLOR_ATTACHMENTS)
	LUAGiEXT(GL_MAX_RENDERBUFFER_SIZE)
	LUAGiEXT(GL_INVALID_FRAMEBUFFER_OPERATION)

	lua_pop(L,1);
}
