/*

    File: main.h

    Copyright (C) 2000-2009 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#ifndef GLUSH_MAIN_H
#define GLUSH_MAIN_H

#include <lua.hpp>

#include "system/system.h"	//timer defs
#include "base/main.h"
#include "program.h"
#include "menu.h"

//statics that everyone gets to see
extern ProgSys progSys;

class GlushModule : public BaseModule {
	typedef BaseModule super;
protected:
	void initCore();		//common code
	void displayFunc();
	
public:
	void initWithGoods(lua_State *L);	//override init
	virtual void init();	//default init
	virtual void initProgSys();
	virtual void reset();

	virtual void shutdown();
	virtual void update();
	virtual void render(const Viewport *vp, const View *v);
};
extern GlushModule glushModule;

void luaStateAddMainCalls(lua_State *L);

#endif